LeetCode #235 - Lowest Common Ancestor of a Binary Search Tree Easy

Problem

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia:

The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”

Example

        _______6______
       /              \
    ___2__          ___8__
   /      \        /      \
   0       4       7       9
          /  \
          3   5

Algorithm

整理一下題意:求兩個節點p和q的最小祖先。最小祖先的定義是,使得子樹包含p和q兩個節點的最低節點。

由於已知這棵樹是二叉搜索樹,所以有左子<父<右子。因此,若當前節點的值比p和q的值都大,則轉到當前節點的左子繼續遞歸;當前節點的值比p和q的值都小,則轉到當前節點的右子繼續遞歸;除以上兩種情況外,其餘情況的最小祖先都是當前節點,直接返回即可。

代碼如下。

//遞歸版本,用時42ms
class Solution {
public:
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        if(root->val>p->val&&root->val>q->val) return lowestCommonAncestor(root->left,p,q);
        if(root->val<p->val&&root->val<q->val) return lowestCommonAncestor(root->right,p,q);
        return root;
    }
};
發佈了63 篇原創文章 · 獲贊 2 · 訪問量 1萬+
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章